module McDump
  module Memcached

    class Item

      def self.parse(dump, items_id)
        dump.scan(/^ITEM (.+?) \[(\d+) b; (\d+) s\]$/).map do |item_data|
          cache_key, size_in_bytes, expires_string = item_data
          self.new(
            items_id:        items_id,
            cache_key:       cache_key,
            expiration_time: Time.at(expires_string.to_i),
            size_in_bytes:   size_in_bytes.to_i
          )
        end
      end

      def initialize(args)
        @data = args
      end

      def to_h
        @data.clone
      end

    end

  end
end
