module McDump
  module Telnet

    class Session

      def self.open(connection_args, &block)
        session = self.new(connection_args)
        block.call(session).tap { session.close }
      end

      def initialize(connection_args)
        @connection = McDump::Telnet::Connection.new(connection_args)
      end

      def stats
        @connection.execute("stats items")
      end

      def items(id, number)
        @connection.execute("stats cachedump #{id} #{number}")
      end

      def close
        @connection.close
      end

    end

  end
end