describe McDump do

  describe "::server" do

    let(:connection_args) { { host: "some.host", port: 12345 } }
    let(:items)           { (1..3).map { instance_double(McDump::Memcached::Item) } }
    let(:server)          { instance_double(McDump::Memcached::Server, items: items) }
    let(:report)          { instance_double(McDump::Report, dump: nil) }

    subject { described_class.server(connection_args) }

    before(:example) do
      allow(McDump::Memcached::Server).to receive(:new).and_return(server)
      allow(McDump::Report).to receive(:new).and_return(report)
    end

    it "creates a server" do
      expect(McDump::Memcached::Server).to receive(:new).with(connection_args)

      subject
    end

    it "retrieves all items from the server" do
      expect(server).to receive(:items)

      subject
    end

    it "creates a report containing the items" do
      expect(McDump::Report).to receive(:new).with(items)

      subject
    end

    it "dumps the contents of the report" do
      expect(report).to receive(:dump)

      subject
    end

  end

end
